$regfile = "m8def.dat"
$crystal = 4000000

Config Lcdpin = Pin , Db4 = Portd.0 , Db5 = Portd.1 , Db6 = Portd.2 , Db7 = Portd.3 , E = Portd.4 , Rs = Portd.5
Config Lcd = 16 * 2

Config Debounce = 30

Declare Sub <()
Declare Sub >()
Declare Sub Enter()
Declare Sub Backlight()

Config Pinc.5 = Output                                      'Relais 1
Config Pinc.4 = Output                                      'Relais 2
Config Pinc.3 = Output                                      'Relais 3
Config Pinc.2 = Output                                      'Relais 4
Config Pinc.1 = Output                                      'Relais 5
Config Pinc.0 = Output                                      'Relais 6
Config Pinb.5 = Output                                      'Relais 7
Config Pinb.4 = Output                                      'Relais 8
Config Pinb.0 = Output                                      'LCD Backlight

Config Pinb.1 = Input                                       'Taster <
Config Pinb.2 = Input                                       'Taster >
Config Pind.6 = Input                                       'Taster Enter
Config Pind.7 = Input                                       'Backlight

Portb.1 = 1
Portb.2 = 1
Portb.4 = 1
Portb.5 = 1

Portc.5 = 1
Portc.4 = 1
Portc.3 = 1
Portc.2 = 1
Portc.1 = 1
Portc.0 = 1

Portd.6 = 1
Portd.7 = 1


Dim R1 As Bit
Dim R2 As Bit
Dim R3 As Bit
Dim R4 As Bit
Dim R5 As Bit
Dim R6 As Bit
Dim R7 As Bit
Dim R8 As Bit
Dim Pointer As Byte
Dim C1a As Bit

R1 = 0
R2 = 0
R3 = 0
R4 = 0
R5 = 0
R6 = 0
R7 = 0
R8 = 0
C1a = 0

Do

Debounce Pinb.1 , 0 , > , Sub
Debounce Pinb.2 , 0 , < , Sub
Debounce Pind.6 , 0 , Enter , Sub
Debounce Pind.7 , 0 , Backlight , Sub

Cls
  Locate 1 , 1
  Lcd "R1R2R3R4R5R6R7R8"
  Locate 2 , 1
  Lcd ; R1 ; " " ; R2 ; " " ; R3 ; " " ; R4 ; " " ; R5 ; " " ; R6 ; " " ; R7 ; " " ; R8 ; " ";
  Waitms 50

Portc.5 = R8                                                'Relais 1
Portc.4 = R7                                                'Relais 2
Portc.3 = R6                                                'Relais 3
Portc.2 = R5                                                'Relais 4
Portc.1 = R4                                                'Relais 5
Portc.0 = R3                                                'Relais 6
Portb.5 = R2                                                'Relais 7
Portb.4 = R1                                                'Relais 8
Portb.0 = C1a                                               'Backlight

Loop
End

Sub Enter():

  If Pointer = 1 Then
    Toggle R1
  End If
  If Pointer = 2 Then
    Toggle R2
  End If
  If Pointer = 3 Then
    Toggle R3
  End If
  If Pointer = 4 Then
    Toggle R4
  End If
  If Pointer = 5 Then
    Toggle R5
  End If
  If Pointer = 6 Then
    Toggle R6
  End If
  If Pointer = 7 Then
    Toggle R7
  End If
  If Pointer = 8 Then
    Toggle R8
  End If

End Sub

Sub <():
  If Pointer >= 2 Then
    Pointer = Pointer - 1
  End If
End Sub

Sub >():
  If Pointer <= 7 Then
    Pointer = Pointer + 1
  End If
End Sub

Sub Backlight():
  If C1a = 1 Then
    C1a = 0
  Else
    C1a = 1
  End If
End Sub